REM -----------------------------------------
REM REPERTOIRES CONTENANT LES EXÉCUTABLES
REM -----------------------------------------
set rep_avr_gcc=C:\Users\JEROME\Documents\ArduinoData\packages\arduino\tools\avr-gcc\7.3.0-atmel3.6.1-arduino5\bin
set rep_avrdude=C:\Users\JEROME\Documents\ArduinoData\packages\arduino\tools\avrdude\6.3.0-arduino17\bin
set rep_avrdudeconf=C:\Users\JEROME\Documents\ArduinoData\packages\arduino\tools\avrdude\6.3.0-arduino17\etc
REM Nota : les specs avr-gcc des différents MCU sont stockés ici : C:\Users\JEROME\Documents\ArduinoData\packages\arduino\tools\avr-gcc\7.3.0-atmel3.6.1-arduino5\lib\gcc\avr\7.3.0\device-specs
REM -----------------------------------------
REM Variables du programme
REM -----------------------------------------
REM pour avr-gcc :
set mcu=atmega16a
set optimizationlevel=3
REM pour avrdude :
set port=usb
set prog=usbasp
set puce=atmega16
REM -----------------------------------------
REM Compilation fichiers C vers mcu ATMEL AVR
REM -----------------------------------------
set rep_programme=%CD%
set rep_programme_output=%CD%\output
@echo off
cls
if not exist "%rep_programme_output%" mkdir "%rep_programme_output%"
REM -----------------------------------------
REM Init couleurs
REM -----------------------------------------
for /F "tokens=1,2 delims=#" %%a in ('"prompt #$H#$E# & echo on & for %%b in (1) do     rem"') do (
  set "DEL=%%a"
)
REM -----------------------------------------
REM 1 - COMPILATION DES FICHIERS.C (output : OBJ)
REM -----------------------------------------
cd /d %rep_avr_gcc%
echo 1) Compilation C vers OBJ
for %%f in ("%rep_programme%\*.c") do (
	REM %%f = fichier 1 par 1, et %%~nf = fichier sans extension
	echo - compilation du fichier "%%f"
	avr-gcc -mmcu=%mcu% -O%optimizationlevel% -c "%rep_programme%\%%~nf.c" -o "%rep_programme_output%\%%~nf.o" 
	IF ERRORLEVEL 1 GOTO FIN
)
call :colorEcho 0a "[REUSSI]"
echo.
echo.
REM -----------------------------------------
REM 2 - GROUPAGE DES FICHIERS.OBJ (output : ELF)
REM -----------------------------------------
echo 2) Groupage des fichiers OBJ en ELF
setlocal enableextensions enabledelayedexpansion
set listefichiersobj=
for %%f in ("%rep_programme_output%\*.o") do (
	if .!listefichiersobj!==. (
		SET listefichiersobj="%%f"
	) ELSE (
		SET listefichiersobj=!listefichiersobj! "%%f"
	)
)
avr-gcc -mmcu=%mcu% %listefichiersobj% -o "%rep_programme_output%\proj.elf"
IF ERRORLEVEL 1 GOTO FIN
call :colorEcho 0a "[REUSSI]"
echo.
echo.
REM -----------------------------------------
REM 3 - TRANSFORMATION EN LANGUAGE ASSEMBLEUR (output : HEX)
REM -----------------------------------------
echo 3) Transformation du fichier ELF en HEX
avr-objcopy -O ihex "%rep_programme_output%\proj.elf" "%rep_programme%\proj.hex"
IF ERRORLEVEL 1 GOTO FIN
call :colorEcho 0a "[REUSSI]"
echo.
echo.
REM -----------------------------------------
REM 4 - ENVOI DU PROGRAMMME AU CPU
REM -----------------------------------------
echo 4) Envoi du programme
cd /d %rep_avrdude%
avrdude -C %rep_avrdudeconf%\avrdude.conf -c %prog% -p %puce% -P %port% -U flash:w:"%rep_programme%\proj.hex":i
IF ERRORLEVEL 1 GOTO FIN
call :colorEcho 0a "[REUSSI]"
echo.
echo.
pause
exit
:FIN
echo.
call :colorEcho 0c "[ERREUR] LE SCRIPT N'A PAS PU ALLER JUSQU'AU BOUT"
echo.
echo.
pause
exit
:colorEcho
echo off
<nul set /p ".=%DEL%" > "%~2"
findstr /v /a:%1 /R "^$" "%~2" nul
del "%~2" > nul 2>&1i